/*
 * JBoss, Home of Professional Open Source
 * Copyright 2007, Red Hat Middleware LLC, and individual contributors
 * as indicated by the @author tags.
 * See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 * This copyrighted material is made available to anyone wishing to use,
 * modify, copy, or redistribute it subject to the terms and conditions
 * of the GNU Lesser General Public License, v. 2.1.
 * This program is distributed in the hope that it will be useful, but WITHOUT A
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License,
 * v.2.1 along with this distribution; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 * (C) 2005-2006,
 * @author JBoss Inc.
 */
//
// Copyright (C) 1998, 1999, 2000, 2001, 2002, 2003
//
// Arjuna Technologies Ltd.,
// Newcastle upon Tyne,
// Tyne and Wear,
// UK.
//
// $Id: Delays.java,v 1.2 2003/06/26 11:43:51 rbegg Exp $
//

package org.jboss.jbossts.qa.CrashRecovery11Utils;

import com.arjuna.ats.arjuna.common.Environment;
import com.arjuna.ats.arjuna.common.arjPropertyManager;

public class Delays
{
	public static int recoveryDelay()
	{
		//
		// get from the propertyManager
		//
		String backoffPeriodString = arjPropertyManager.propertyManager.getProperty(Environment.RECOVERY_BACKOFF_PERIOD);
		String recoveryPeriodString = arjPropertyManager.propertyManager.getProperty(Environment.PERIODIC_RECOVERY_PERIOD);

		try
		{
			Integer recoveryPeriodInteger = new Integer(recoveryPeriodString);
			int _recoveryPeriod = recoveryPeriodInteger.intValue();

			Integer backoffPeriodInteger = new Integer(backoffPeriodString);
			int _backoffPeriod = backoffPeriodInteger.intValue();

			return (_backoffPeriod + _recoveryPeriod + (5 * 1000) /*5 secs for processing*/);
		}
		catch (NumberFormatException e)
		{
			return 30 * 1000;
		}
	}
}
